
#pragma once
#include "oleidl.h"

class CMyDropTarget :
	public IDropTarget
{
public:
	CMyDropTarget(CEdit* pDropCtrl);
	~CMyDropTarget(void);

protected:
	//IUnknown implementation
	HRESULT __stdcall QueryInterface (REFIID iid, void** ppvObject);
	ULONG	__stdcall AddRef (void);
	ULONG	__stdcall Release (void);

	//IDropTarget implementation
	HRESULT __stdcall DragEnter (IDataObject* pDataObject, DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);
	HRESULT __stdcall DragOver (DWORD grfKeyState, POINTL pt, DWORD * pdwEffect);
	HRESULT __stdcall DragLeave (void);
	HRESULT __stdcall Drop (IDataObject* pDataObject, DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);

private:
	LONG m_lRefCount;
	CWnd* pDropWnd;
	CEdit* pEditWnd;
	CEdit m_Edit;
	BOOL m_fAllowDrop;
	BOOL QueryDataObject(IDataObject* pDataObject);
	DWORD DropEffect(DWORD grfKeyState, POINTL pt, DWORD dwAllowed);
	void SelectControl(POINTL pt);
public:
	static BOOL RegisterDragDropWnd(CEdit* pEditCtrl, IDropTarget** ppDropTarget);
	static BOOL UnregisterDragDropWnd(CEdit* pEditCtrl, IDropTarget* pDropTarget);
private:
	BOOL DropData(IDataObject* pDataObject);
};
